// App.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "App.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "exeDoc.h"
#include "exeView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// App

App* pObj;

App*	App_GetApp()
{
	return pObj;
}

//---------------------------------------------------------------------------
// instantiation of the interface class object
BOOL App_GetClassObject(int nClsid, int nId, void** ppvObj)
{
    ASSERT(nClsid == CLSID_APP);
    ASSERT(nId == IID_IDocument);

	pObj = new App;
	MyIUnknown* pUnk = &pObj->m_xDocument; 

	if(pUnk->QueryInterface( nId, ppvObj ))
	{
		pObj->ExternalRelease();		// to balance m_dwRef, ref counter
		return TRUE;
	}
    return FALSE;
}

//---------------------------------------------------------------------------
// ctor
App::App()
{
    TRACE("App::ctor\n");
}

//---------------------------------------------------------------------------
// dtor
App::~App()
{
    TRACE("App::dtor\n");
}

//---------------------------------------------------------------------------
// ExternalQueryInterface
BOOL App::ExternalQueryInterface(int nId, void** ppvObj) 
{
	TRACE("Entering App::ExternalQueryInterface--nIid = %d\n" ,nId);
    switch (nId) {
    case IID_IDocument:
       *ppvObj = &m_xDocument;
      break;
    default:
      *ppvObj = NULL;
      return FALSE;
    }
    ExternalAddRef();
    return TRUE;
}                               

//---------------------------------------------------------------------------
// OnFinalRelease
void App::OnFinalRelease()
{
    TRACE("AnRcp::OnFinalRelease\n");
	CCmdTarget::OnFinalRelease();
}

//---------------------------------------------------------------------------
// XDocument implementation
DWORD App::XDocument::AddRef()
{
    TRACE("App::XDocument::AddRef\n");
    MY_METHOD_PROLOGUE(App, Document)
    return pThis->ExternalAddRef();
}

DWORD App::XDocument::Release()
{
    TRACE("App::XDocument::Release\n");
    MY_METHOD_PROLOGUE(App, Document)
    return pThis->ExternalRelease();
}

BOOL App::XDocument::QueryInterface( int nId, void** ppvObj )
{
    MY_METHOD_PROLOGUE(App, Document)
    return pThis->ExternalQueryInterface(nId, ppvObj);
}

//---------------------------------------------------------------------------
// Create document template
//		nId:	document type
CDocTemplate* App::XDocument::CreateDocTempl( CWinApp* pWinApp, int nId )
{
    TRACE("App::XDocument::OpenDocTempl\n");
    MY_METHOD_PROLOGUE(App, Document)

	pThis->m_pWinApp = pWinApp;

	pThis->SetRsc();	// setup DLL resource handler

	CDocTemplate* ret;

	switch (nId)
	{
	case C_DOC_1:
	pThis->m_pDoc1Templ = new CMultiDocTemplate(
			IDR_EXETYPE,
			RUNTIME_CLASS(CExeDoc),
			RUNTIME_CLASS(CChildFrame),
			RUNTIME_CLASS(CExeView));

	pThis->m_pWinApp->AddDocTemplate( pThis->m_pDoc1Templ );
	ret = pThis->m_pDoc1Templ;
	break;
/*
	case C_DOC_2:
	pThis->m_pDoc2Templ = new CMultiDocTemplate(
			IDR_VIEW2,
			RUNTIME_CLASS(CExeDoc),
			RUNTIME_CLASS(CChildFrame2),
			RUNTIME_CLASS(CExeView));

	pThis->m_pWinApp->AddDocTemplate( pThis->m_pDoc2Templ );
	ret = pThis->m_pDoc2Templ;
	break;
*/
	default:
		TRACE1("App::XDocument::CreateDocTempl; ID inknown %d\n", nId);
		ret = NULL;
	}

	pThis->RestoreRsc();	// restore client's resource handler

	return ret;
}

//---------------------------------------------------------------------------
// create main MDI Frame window
void App::XDocument::CreateFrame()
{
    MY_METHOD_PROLOGUE(App, Document)

	pThis->SetRsc();

	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		ASSERT( 0 );
	pThis->m_pWinApp->m_pMainWnd = pMainFrame;

//	pThis->RestoreRsc();
}

//---------------------------------------------------------------------------
// Handle resources
void App::SetRsc()
{
	m_hDLL = ::GetModuleHandle("dll.dll");
	m_hEXE = AfxGetResourceHandle();
	AfxSetResourceHandle((HINSTANCE) m_hDLL);
}

void App::RestoreRsc()
{
	AfxSetResourceHandle(m_hEXE);
}
